#ifndef _AT_SCREEN_HEAD
#define _AT_SCREEN_HEAD

#include <stdlib.h>

#define MAX_MINISCRBLK	8

typedef struct tagPNTBlk {
	BYTE nSizeX,nSizeY;
	WORD PNTCode[1];
	}PNTBLK;

typedef struct tagMiniScreen {
	WORD BlkNum;
	WORD PGTSize;
	WORD *lptrPalette;
	BYTE *lptrPGTTab;
	PNTBLK *lptrPNTBlk[1];
	}MINISCR;

typedef struct tagMiniScrBlk {
	WORD StartPGTCode;
	WORD PGTSize;
	short int ColorArea;
	WORD Reserve;
	MINISCR *lptrMiniScr;
	}MINISCRBLK;

typedef struct tagMiniScrContainer {
	WORD PNTAddress;
	WORD StartPGTCode;
	WORD MaxPGTSize;
	/*-------- System Reserve --------*/
	WORD CurrentPGTCode;
	short int BlkNum;		/*С*/
	MINISCRBLK ScrBlk[MAX_MINISCRBLK];
	}MINISCRCONTAINER;

/*===================== Mini Screen Blk =================*/
void InitMiniScreen(MINISCRCONTAINER *lptrMiniScrContainer,BOOL bInitPNT);
void InitMiniScreenEx(MINISCRCONTAINER *lptrMiniScrContainer,BOOL bInitPNT,WORD EmptyCode);
short int AppendMiniScreen(MINISCR *lptrMiniScreen,short int ColorArea,BOOL bInitColor);
short int AppendMiniScreenEx(MINISCR *lptrMiniScreen,short int ColorArea,BOOL bInitColor,WORD StartPGTCode);
void PutMiniScrBlkEx(short int PosX,short int PosY,short int BlkIndex,short int ItemIndex,
	WORD PNTPri,WORD PNTAddress);
void GetMiniScrInfor(short int BlkIndex,MINISCRBLK *lptrMiniScrBlk);
void DestoryMiniScreen(void);
WORD *GetMiniPalette(short int BlkIndex);
void GetMiniScrSize(short int BlkIndex,short int ItemIndex,SIZE *lptrSize);

#endif