#include <stdio.h>
#include <stdlib.h>
#include <zlib.h>
#include <Music.h>
#include <Compress.h>
#include "screen.h"

#define WINDOW_SIZEY			20

#define FFTVIEW_X	30
#define	FFTVIEW_Y	19

void ShowMusicName(int WinIndex, int PosIndex);

int OldWinIndex;
int OldPosIndex;

short int SndBarIndex;
extern MINISCR *MiniScreenTab[1];

extern CHANNELSTATE ChannelState[];
extern SPEECHDATA TestSpeech[];

extern COMPRESSDATA ZipData;

int MusicVolume;

main()		
	{
	int i;
	int WinIndex;		/*ʼλõֵ*/
	int PosIndex;		/*ڵֵ*/
	MINISCRCONTAINER TempMiniScr;
	/*-----------------ѹ---------------*/
	BYTE *lptrDecompress;
	int hUnzipStream;
	int x,y,Index;
	int SkipCount;

	InitMusic();
	SkipCount = 0;

	OldWinIndex = -1;
	OldPosIndex = -1;

	MusicVolume = 127;

	TempMiniScr.PNTAddress	= 0xA000;
	TempMiniScr.StartPGTCode= 128;
	TempMiniScr.MaxPGTSize	= MiniScreenTab[0]->PGTSize + TempMiniScr.StartPGTCode;
	/*-------------------------------------------*/
	SetTextMode();

	/*=============== Test Decompress ڽʱθó==============*/
	/*ѹĳʼ*/
/*	lptrDecompress = malloc(8192);

	InitCompressSys();

	hUnzipStream = OpenCompressData(&ZipData, TRUE);
	if(hUnzipStream == -1)
		{
		gprintf(10, 10, "Call OpenCompressData Fail!");
		while(1);
		}

	ReadCompressData(hUnzipStream, lptrDecompress, 8192);
	Index = 0;
	for(y =0; y<27; y++)
		{
		char TextBuffer[64];
		memset(TextBuffer, 0, 64);
		for(i=0; lptrDecompress[Index] != 0x0d; Index++,i++)
			if(i<40)	
				{
				if(lptrDecompress[Index] == '\t')
					{
					TextBuffer[i++] = ' ';
					TextBuffer[i++] = ' ';
					TextBuffer[i++] = ' ';
					TextBuffer[i] = ' ';
					}
				else
					TextBuffer[i] = lptrDecompress[Index];
				}
		TextBuffer[40] = 0x00;
		gprintf(0, y+1, TextBuffer);
		Index += 2;
		}

	CloseCompressData(hUnzipStream);
	while(1);			/*!!!!!!!!!!!!*/
	/*==============================================*/

	InitMiniScreen(&TempMiniScr,TRUE);
	_WriteVDPRegister(2,0x28);		/*Layer A:A000H	*/
	SndBarIndex=AppendMiniScreen(MiniScreenTab[0],1,TRUE);/*ָʾ*/

	PutMiniScrBlk(FFTVIEW_X,FFTVIEW_Y,SndBarIndex,96,0x8000);

	for(i=0; i<6; i++)
		PutMiniScrBlk(FFTVIEW_X+i+1,FFTVIEW_Y+1,SndBarIndex,i*16,0x8000);

	WinIndex = 0;
	PosIndex = 0;
	gprintf(3, 1, "Music Test 1.10e for MIDI(PAL)");

	for(i=0; i<40; i++)	
		{
		gprintf(i,2,"=");
		gprintf(i,25,"=");
		}
	gprintf(1, 26, "UP/DOWN for move cursor,START play it");
	gprintf(3, 27, "By: Tomsoft Studio. @2002");
	/*-------------------------------------------*/
	ShowMusicName(WinIndex, PosIndex);
	while(1)
		{
		if(Key1Down & (KEY_UP | KEY_DOWN | KEY_START))
			{
			if((Key1Down & KEY_UP) == KEY_UP)
				{
				Key1Down &= ~KEY_UP;
				if(PosIndex != 0)
					{
					PosIndex --;
					ShowMusicName(WinIndex, PosIndex);
					}
				else
					if(WinIndex != 0)
						{
						WinIndex --;
						ShowMusicName(WinIndex, PosIndex);
						}
				}

			if((Key1Down & KEY_DOWN) == KEY_DOWN)
				{
				Key1Down &= ~KEY_DOWN;
				if((WinIndex+PosIndex+1) < GetTotalMusic())
					if((PosIndex+1) < WINDOW_SIZEY)
						{
						PosIndex++;
						ShowMusicName(WinIndex, PosIndex);
						}
					else
						{
						WinIndex++;
						ShowMusicName(WinIndex,PosIndex);
						}
				}
			if((Key1Down & KEY_START) == KEY_START)
				{
				Key1Down &= ~KEY_START;
				PlayMusic(WinIndex+PosIndex,FALSE);
				}
			}
		if((Key1Down & KEY_A) == KEY_A)
			{
			Key1Down &= ~KEY_A;
			PlaySpeech(TestSpeech);
			}
		if((Key1Down & KEY_B) == KEY_B)
			{
			Key1Down &= ~KEY_B;
			StopMusic();
			}
		if(Key1Port & (KEY_X | KEY_Y) && (SkipCount & 0x03) == 0)
			{
			if((Key1Port & KEY_X) == KEY_X)
				{
				if(MusicVolume != 0)
					{
					MusicVolume --;
					SetMusicVolume(MusicVolume);
					ShowMusicName(WinIndex, PosIndex);
					}
				}
			if((Key1Port & KEY_Y) == KEY_Y)
				{
				if(MusicVolume < 127)
					{
					MusicVolume ++;
					SetMusicVolume(MusicVolume);
					ShowMusicName(WinIndex, PosIndex);
					}
				}
			}
		for(i=0; i<6; i++)
			{
			if(ChannelState[i].bNoteOn == 1)
				{
				PutMiniScrBlk(FFTVIEW_X+i+1,FFTVIEW_Y+1,SndBarIndex,
					(int)(ChannelState[i].Volume >> 3)+i*16,0x8000);
				if(ChannelState[i].Volume == 0)
					ChannelState[i].bNoteOn = 0;
				else
					{
					if(ChannelState[i].Volume >=3 )	
						ChannelState[i].Volume -=3;
					else
						ChannelState[i].Volume = 0;
					}
				}
			}
		for(i=0; i<0x001fff; i++);
		SkipCount ++;
		}
	}

void ShowMusicName(int WinIndex, int PosIndex)
	{
	char TextBuffer[256];
	short int x,y,i;
	int CursorY;
	int StartY = (224/8 - WINDOW_SIZEY) / 2;

	if(OldWinIndex == WinIndex)
		gprintf(0, OldPosIndex+StartY, "  ");
	else
		{
		for(y=0; y<WINDOW_SIZEY && (WinIndex+y) < GetTotalMusic(); y++)
			{
			sprintf(TextBuffer,"%03d: %s", WinIndex+y,GetMusicName(WinIndex+y));
			for(i=strlen(TextBuffer); i<38-2; i++) TextBuffer[i]=' ';
			if(i>36)	i=36;
			TextBuffer[i]=0x00;
			gprintf(2, y+StartY, TextBuffer);
			}
		}
	sprintf(TextBuffer, "-= MusicVolume: %d =-  ", MusicVolume);
	gprintf(8, StartY+WINDOW_SIZEY, TextBuffer);
	CursorY = (WinIndex+PosIndex) * WINDOW_SIZEY / GetTotalMusic();
	for(y=0; y<WINDOW_SIZEY; y++)
		{
		if(y == CursorY)
			gprintf(38, StartY+y, "[]");
		else
			gprintf(38, StartY+y, "||");
		}
	gprintf(38, StartY-1, "^^");
	gprintf(38, StartY+WINDOW_SIZEY, "vv");
	gprintf(0, PosIndex+StartY, "->");
	OldPosIndex = PosIndex;
	OldWinIndex = WinIndex;
	}

interrupt void HIntEntry(void)
	{
	}

interrupt void ExternalEntry(void)
	{
	}

interrupt void VIntEntry(void)
	{
	MusicProc();
	_ReadKey();
    }

