
/************************************************************************/
/* Copyright (c) 1988-1991 Microtec Research, Inc.			*/
/* ALL RIGHTS RESERVED							*/
/************************************************************************/

/*  <stddef.h>   Microtec Research, Inc. ANSI C Compiler  */
/* %W% %G% */

#ifndef __STDDEF_H
#define __STDDEF_H	1

#if __STDC__

    #ifdef _PTRDIFF_T
	typedef _PTRDIFF_T ptrdiff_t;
    #else
	typedef int ptrdiff_t;
    #endif

    #ifndef __STDLIB_H
	#ifdef _WCHAR_T
	    typedef _WCHAR_T wchar_t;
	#else
	    typedef unsigned char wchar_t;
	#endif
    #endif /* __STDLIB_H */

    #define offsetof(s,m) ((size_t)&(((s*)0)->m))

    #if ! (__STDIO_H || __STDLIB_H || __STRING_H || __TIME_H)

	#ifdef _sun
	    typedef int size_t;
	#else
	    #ifdef _SIZE_T
		typedef _SIZE_T size_t;
	    #else
		typedef unsigned size_t;
	    #endif
	#endif

    #endif /* ! (__STDIO_H || __STDLIB_H || __STRING_H || __TIME_H) */

#else	/* ! __STDC__ */

    #define offsetof(s,m) ((unsigned)&(((s*)0)->m))

#endif	/* ! __STDC__ */

#if __cplusplus
    #define	NULL		(0)
#else
    #define	NULL		((void *)0)
#endif

#endif /* end __STDDEF_H */
