
/************************************************************************/
/* Copyright (c) 1988-1991, 1992, 1993 Microtec Research, Inc.		*/
/* ALL RIGHTS RESERVED							*/
/************************************************************************/

/*  <assert.h>   Microtec Research, Inc. ANSI C Compiler  */
/* %W% %G% */

#undef assert

#ifdef NDEBUG

    #define assert(ignore) ((void)0)

#else

    #if __cplusplus
	extern "C" {
    #endif

	void _ASSERT (const char *, const char *, int);

    #if __cplusplus
	}
    #endif

    #define assert(exp) ((void) ((exp) ? (void) 0 : _ASSERT(#exp, __FILE__, \
	__LINE__) ))

#endif
