#ifndef _AT_DIO_HFILE
#define _AT_DIO_HFILE

#include <stdlib.h>

#define MAX_DIONUM	64
#define MAX_REFSIZE		128

typedef struct tagDIO {
	short int x,y;
	WORD SprPri;		
	WORD DIOCode;	/*0xffff ն*/				
	BYTE ColorArea;		/*ʹɫ0..3*/
	BYTE Reserve;
	}DIO;

typedef struct tagDIOInfor {
	WORD PGTStartAddress;			/*Patten*/
	WORD PGTSize;					/*Patten*/
	WORD InforStartAddress;			/*ʵVRAMַ*/
	}DIOINFOR;

typedef struct tagPreload {
	WORD StaticPGTSize;
	WORD nSize;
	WORD Table[1];
	}PRELOAD;
	
void InitDIO(DIOINFOR *lpDIOInfor);
void SetDIOPalette(short int ColorArea,WORD *Palette);
void DestroyDIO(void);
short int AllocDIO(void);
WORD SetDIOPri(short int SprIndex,WORD NewSprPri);
void DisplayDIO(void);
BOOL PreloadSprite(PRELOAD *lptrPreloadTab);

#endif
