
/************************************************************************/
/* Copyright (c) 1988-1991 Microtec Research, Inc.			*/
/* ALL RIGHTS RESERVED							*/
/************************************************************************/

/*  <signal.h>   Microtec Research, Inc. ANSI C Compiler  */
/* %W% %G% */

#ifndef __SIGNAL_H
#define __SIGNAL_H	1

typedef unsigned char sig_atomic_t;

#define SIG_DFL (void (*)(int))0
#define SIG_IGN (void (*)(int))2
#define SIG_ERR (void (*)(int))4

#define SIGABRT 9    /* kill */
#define SIGFPE  8    /* floating point exception */
#define SIGILL  4    /* illegal instruction */
#define SIGINT  2    /* interrupt */
#define SIGSEGV 11   /* segmentation violation */
#define SIGTERM 15   /* software termination signal from kill */

#endif /* end __SIGNAL_H */
