;************************************************************************
;* THIS INFORMATION IS PROPRIETARY TO									*
;* MICROTEC RESEARCH, INC.												*
;* 2350 Mission College Blvd.											*
;* Santa Clara, CA 95054												*
;* USA																	*
;*----------------------------------------------------------------------*
;* Copyright (c) 1993  Microtec Research, Inc.							*
;* ALL RIGHTS RESERVED													*
;************************************************************************
;* 	%W% %G%	*
;
; 		MCC68K V4.4 Default Linker Command File
;
listabs	publics,internals
listmap	publics
format  s
extern	ENTRY			; force load of initialization routine
chip    68000,24
;
; If linking with MCC68K 3.x objs, enable the next 4 lines:
;
;   alias code,9		; 9  was default value of $CODESEG in 3.x
;   alias zerovars,14	; 14 was default value of $DATASEG in 3.x
;   alias vars,13		; 13 was default value of $INITSEG in 3.x
;   alias heap,15		; 15 was heap section in 3.x
;
sect			entry=$0000		; set starting address of main entry;
sect			interrupt=$0064	; set starting address of user interrupt section
sectsize		interrupt=$0020	; set user interrupt section size.
sect			title=$0100		; set starting address of title section
sectsize		title=$0100		; set title section size
alignmod        PGT=32          ; adjust alignment of PGT section to long word
sect			vars=$ff0000
sectsize        heap=$c000      ; set size of heap
sectsize        stack=$2000     ; set size of stack
common          stack=$ffe000   ; set starting address of stack section
alignmod		ioports=4		; adjust alignment of ioports to long word
initdata		vars, tags		; initialize vars and tags sections
;
order   PGT,z80_program,code,const,literals,strings,??INITDATA  ; ROM -- C sections
order   ehscfn,ehsftbl,initfini,pixinit,ADFFile     ; ROM -- C++ sections
order	vars,zerovars,tags,ioports,heap				; RAM -- C sections
order	stack										; RAM -- stack section
;
; In the following linker commands, "<lib_dir>" should be set to
; "/usr/mri/lib/" for UNIX and "C:\mcc68k\680XX\" for MSDOS.
;
; If using A5-relative data addressing, enable the next 2 lines:
;
; index	?a5,vars,$8000		      ; A5 reg must be set to ?A5 in entry.c
; load  <lib_dir>mcc68ka5XX.lib	      ; Modify to access correct library
