// EBXLIstDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EBXLIst.h"
#include "EBXLIstDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEBXLIstDlg dialog

CEBXLIstDlg::CEBXLIstDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEBXLIstDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEBXLIstDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEBXLIstDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEBXLIstDlg)
	DDX_Control(pDX, IDC_LIST1, m_xList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEBXLIstDlg, CDialog)
	//{{AFX_MSG_MAP(CEBXLIstDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON4, OnTop)
	ON_BN_CLICKED(IDC_BUTTON5, OnVCenter)
	ON_BN_CLICKED(IDC_BUTTON6, OnBottom)
	ON_BN_CLICKED(IDC_BUTTON1, OnLeft)
	ON_BN_CLICKED(IDC_BUTTON2, OnCenter)
	ON_BN_CLICKED(IDC_BUTTON3, OnRight)
	ON_BN_CLICKED(IDC_BUTTON7, OnAdd)
	ON_BN_CLICKED(IDC_BUTTON8, OnInsert)
	ON_BN_CLICKED(IDC_BUTTON9, OnActivate)
	ON_BN_CLICKED(IDC_BUTTON10, OnFGColour)
	ON_BN_CLICKED(IDC_BUTTON11, OnBGColour)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEBXLIstDlg message handlers

BOOL CEBXLIstDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_xList.SetItemHeight(20);
	m_xList.AddItem("First string");
	m_xList.AddItem("Last string");
	m_xList.InsertItem("Middle string #1", 1, RGB(50,  100, 150), RGB(255, 255,255));
	m_xList.InsertItem("Middle string #1", 1, RGB(100, 150, 200), RGB(255, 255,255));
	m_xList.InsertItem("Middle string #1", 1, RGB(150, 200, 250), RGB(255, 255,255));
	m_xList.InsertItem("Middle string #1", 1, RGB(200, 250, 0),	  RGB(255, 255,255));
	m_xList.InsertItem("Middle string #1", 1, RGB(250, 0,   50),  RGB(255, 255,255));
	m_xList.InsertItem("Middle string #1", 1, RGB(100, 50,  100), RGB(255, 255,255));

	m_xList.InsertItem("Middle string #1", 1, 12432321, RGB(255, 255,255));

	m_xList.SetActive(FALSE, 2);
	m_xList.SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEBXLIstDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEBXLIstDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEBXLIstDlg::OnTop()		{	m_xList.SetVal(DT_TOP);		}
void CEBXLIstDlg::OnVCenter()	{	m_xList.SetVal(DT_VCENTER);	}
void CEBXLIstDlg::OnBottom()	{	m_xList.SetVal(DT_BOTTOM);	}

void CEBXLIstDlg::OnLeft()		{	m_xList.SetHal(DT_LEFT);	}
void CEBXLIstDlg::OnCenter()	{	m_xList.SetHal(DT_CENTER);	}
void CEBXLIstDlg::OnRight()		{	m_xList.SetHal(DT_RIGHT);	}

void CEBXLIstDlg::OnAdd() 
{
	// copy colours from the current item
	m_xList.AddItem("Added ITEM", m_xList.GetBg(),  m_xList.GetFg());
}

void CEBXLIstDlg::OnInsert() 
{
	m_xList.InsertItem("Inserted ITEM", m_xList.GetCurSel(), m_xList.GetBg(),  m_xList.GetFg());
}

// Toggle between active and non active state
void CEBXLIstDlg::OnActivate()	{	m_xList.SetActive(!m_xList.GetActive());	}

void CEBXLIstDlg::OnFGColour() 
{
	CColorDialog dlg;
	dlg.DoModal();
	m_xList.SetFg(dlg.GetColor());	
}

void CEBXLIstDlg::OnBGColour() 
{
	CColorDialog dlg;
	dlg.DoModal();
	m_xList.SetBg(dlg.GetColor());	
}
